function vimp = do_single_pass_of_var_imp(options, savefilename, num_run, Xtrain, ytrain, Xvalid, yvalid, Xtest, ytest, cat, catDomains, featureNames, num_feats_wanted, num_params_wanted, num_params)
fprintf(strcat(['Sample ', num2str(num_run), ' for importance analysis of model ', options.unique_model_name, ' ...\n']));
savefilename = strcat(savefilename, '_', num2str(num_run));

Xfull_train = [Xtrain; Xvalid];
yfull_train = [ytrain; yvalid];

vimp.full_rmse = get_rmse(Xfull_train, yfull_train, Xtest, ytest, cat, catDomains, options, featureNames, 1:size(Xtrain,2));

numFeaturesToSelect = 10; %size(X,2);
if nargin < 13
    [selected_feature_idxs, selected_feature_indices_in_order_added, orig_rmses, origEmptyModelRMSE] = fwdSelection(Xtrain, ytrain, Xvalid, yvalid, options, cat, catDomains, featureNames, numFeaturesToSelect);
else
    [selected_feature_idxs, selected_feature_indices_in_order_added, orig_rmses, origEmptyModelRMSE] = fwdSelection(Xtrain, ytrain, Xvalid, yvalid, options, cat, catDomains, featureNames, num_feats_wanted, num_params_wanted, num_params);
end
rmses = [];
redo_orig_rmses = [];
for j=1:length(selected_feature_indices_in_order_added)
    sel_feats = sort(selected_feature_indices_in_order_added(1:j));
    rmses(end+1) = get_rmse(Xfull_train, yfull_train, Xtest, ytest, cat, catDomains, options, featureNames, sel_feats);
    redo_orig_rmses(end+1) = get_rmse(Xtrain, ytrain, Xvalid, yvalid, cat, catDomains, options, featureNames, sel_feats);
end
emptyModelRMSE = get_rmse(Xfull_train, yfull_train, Xtest, ytest, cat, catDomains, options, featureNames, []);
redo_orig_empty_model_rmse = get_rmse(Xtrain, ytrain, Xvalid, yvalid, cat, catDomains, options, featureNames, []);
rmses
fprintf(strcat(['Forward selection complete, now assessing importance of each feature in the subset']));
% [tmpXTrain,tmpXtest,tmpCat,tmpCatDomains,tmpFeatureNames] = use_feat_subset(Xtrain,Xtest,cat,catDomains,featureNames,selected_feature_idxs);
% [importance, fullRMSE, subRMSE] = varImportance(tmpXTrain, ytrain, tmpXtest, ytest, options, tmpCat, tmpCatDomains, tmpFeatureNames);
[tmpXFullTrain,tmpXtest,tmpCat,tmpCatDomains,tmpFeatureNames] = use_feat_subset(Xfull_train,Xtest,cat,catDomains,featureNames,selected_feature_idxs);
[importance, fullRMSE, subRMSE] = varImportance(tmpXFullTrain, yfull_train, tmpXtest, ytest, options, tmpCat, tmpCatDomains, tmpFeatureNames);

vimp.featureNames = featureNames;
vimp.selected_feature_idxs = selected_feature_idxs;
vimp.selected_feature_indices_in_order_added = selected_feature_indices_in_order_added;
vimp.rmses = rmses;
vimp.orig_rmses = orig_rmses;
vimp.origEmptyModelRMSE = origEmptyModelRMSE;
vimp.emptyModelRMSE = emptyModelRMSE;
vimp.redo_orig_empty_model_rmse = redo_orig_empty_model_rmse;
vimp.redo_orig_rmses = redo_orig_rmses;
vimp.importance = importance;
vimp.fullRMSE = fullRMSE;
vimp.subRMSE = subRMSE;
vimp.options = options;
savefilename = strcat(savefilename, '_', options.unique_model_name);
save(savefilename, 'vimp');

% function do_var_imp(options_vec, savefilename, X, y, cat, catDomains, featureNames)
%     perm = randperm(size(X,1));
%     trainsize = ceil(length(perm)/3*2);
%     train_idxs = perm(1:trainsize);
%     test_idxs = perm(trainsize+1:end);
%     for i=1:length(options_vec)
%         options = options_vec{i};
%         vimp.full_rmse(i) = get_rmse(X(train_idxs,:), y(train_idxs), X(test_idxs,:), y(test_idxs), cat, catDomains, options, featureNames, 1:size(X,2));
%         
%         numFeaturesToSelect = 10;
%         [selected_feature_idxs{i}, selected_feature_indices_in_order_added{i}, rmses{i}] = fwdSelection(X(train_idxs,:), y(train_idxs), X(test_idxs,:), y(test_idxs), options, cat, catDomains, featureNames, numFeaturesToSelect);
%         [tmpXTrain,tmpXValid,tmpCat,tmpCatDomains,tmpFeatureNames] = use_feat_subset(X(train_idxs,:),X(test_idxs,:),cat,catDomains,featureNames,selected_feature_idxs{i});
%         importance{i} = varImportance(tmpXTrain, y(train_idxs), tmpXValid, y(test_idxs), options, tmpCat, tmpCatDomains, tmpFeatureNames) %#ok<AGROW>
%     end
%     
%     vimp.featureNames = featureNames;
%     vimp.selected_feature_idxs = selected_feature_idxs;
%     vimp.selected_feature_indices_in_order_added = selected_feature_indices_in_order_added;
%     vimp.rmses = rmses;
%     vimp.importance = importance;
%     vimp.options_vec = options_vec;
% 	save(savefilename, 'vimp');
% end