function plot_matrices_same_scale

names = {};
names{end+1} = 'CPLEX12-cat-BIGMIX';
names{end+1} = 'CPLEX12-cat-CORLAT';
names{end+1} = 'CPLEX12-cat-REG';
names{end+1} = 'CPLEX12-cat-CORLAT-REG';
names{end+1} = 'CPLEX12-cat-RCW';
names{end+1} = 'CPLEX12-cat-CORLAT-REG-RCW';
names{end+1} = 'SPEAR-ibm-al';
names{end+1} = 'SPEAR-swv-al';
names{end+1} = 'SPEAR-ibm-swv-al';
names{end+1} = 'LKH-TSPLIB';


% elements = {'trainC_trainI', 'trainC_testI', 'testC_trainI', 'testC_testI'};
elements = {'testC_testI'};


for j=1:length(names)
    name = names{j};
    min_val = inf;
    max_val = -inf;
    for i=1:length(elements)
        el = elements{i};

        fighandles = get_handles(name,el);
        for figno = 1:length(fighandles)
            a = getimage(fighandles{figno}{2});
            max_val = max(max(max(a)), max_val);
            min_val = min(min(min(a)), min_val);
        end
    end
    
    for i=1:length(elements)
        el = elements{i};
        fighandles = get_handles(name,el);
        
        matrices = {};
        for figno = 2:length(fighandles)
            matrices{figno} = getimage(fighandles{figno}{2});
        end
        
        for figno = 2:length(fighandles)
            matrix = matrices{figno};
            filename_prefix = strcat(['results/matrix/2d/redone/', name, '-', fighandles{figno}{1}, el]);
            plot_figure(filename_prefix, matrix, min_val, max_val);
        end
        
        matrix = getimage(fighandles{1}{2});
        mkdir('/ubc/cs/project/arrow/hutter/EPMs/results/matrix/2d/redone/');
        filename_prefix = ['/ubc/cs/project/arrow/hutter/EPMs/results/matrix/2d/redone/',name,'-truematrix-', el];
        plot_figure(filename_prefix, matrix, min_val, max_val);
    end
	close all;
end

function fighandles = get_handles(name, el)
%% Predictive performance with different models and 10000 data points.
% fighandles = {};
% fighandles{end+1} = {'true', openfig(['/ubc/cs/project/arrow/hutter/EPMs/results/matrix/2d/',name,'-truematrix-', el, '.fig'])};
% fighandles{end+1} = {'RF-def-10000', openfig(['/ubc/cs/project/arrow/hutter/EPMs/results/matrix/2d/',name,'-10000-predmatrix-', el, '-RF-def.fig'])};
% fighandles{end+1} = {'RT-10000', openfig(['/ubc/cs/project/arrow/hutter/EPMs/results/matrix/2d/',name,'-10000-predmatrix-', el, '-RT.fig'])};
% fighandles{end+1} = {'GP-10000', openfig(['/ubc/cs/project/arrow/hutter/EPMs/results/matrix/2d/',name,'-10000-predmatrix-', el, '-GP.fig'])};
% fighandles{end+1} = {'NN-10000', openfig(['/ubc/cs/project/arrow/hutter/EPMs/results/matrix/2d/',name,'-10000-predmatrix-', el, '-NN.fig'])};
% fighandles{end+1} = {'Foba-rmse-10000', openfig(['/ubc/cs/project/arrow/hutter/EPMs/results/matrix/2d/',name,'-10000-predmatrix-', el, '-Foba-rmse.fig'])};
% fighandles{end+1} = {'RR-10000', openfig(['/ubc/cs/project/arrow/hutter/EPMs/results/matrix/2d/',name,'-10000-predmatrix-', el, '-RR.fig'])};

%% Scaling performance of RFs with the number of data points.
% fighandles = {}
% fighandles{end+1} = {'RF-def10000', openfig(['/ubc/cs/project/arrow/hutter/EPMs/results/matrix/2d/',name,'-10000-predmatrix-', el, '-RF-def.fig'])};
% fighandles{end+1} = {'RF-def5000000-',openfig(['/ubc/cs/project/arrow/hutter/EPMs/results/matrix/2d/',name,'-5000000-predmatrix-', el, '-RF-def.fig'])};
% fighandles{end+1} = {'RF-def100-',openfig(['/ubc/cs/project/arrow/hutter/EPMs/results/matrix/2d/',name,'-100-predmatrix-', el, '-RF-def.fig'])};
% fighandles{end+1} = {'RF-def1000-',openfig(['/ubc/cs/project/arrow/hutter/EPMs/results/matrix/2d/',name,'-1000-predmatrix-', el, '-RF-def.fig'])};

%% Predictive performance with different models and 10000 data points.
fighandles = {};
fighandles{end+1} = {'true', openfig(['/ubc/cs/project/arrow/hutter/EPMs/results/matrix/2d/',name,'-truematrix-', el, '.fig'])};
fighandles{end+1} = {'RF-def-10000-sub1', openfig(['/ubc/cs/project/arrow/hutter/EPMs/results/matrix/2d/',name,'-10000-sub1-predmatrix-', el, '-RF-def.fig'])};
fighandles{end+1} = {'RF-def-10000-sub2', openfig(['/ubc/cs/project/arrow/hutter/EPMs/results/matrix/2d/',name,'-10000-sub2-predmatrix-', el, '-RF-def.fig'])};
fighandles{end+1} = {'RF-def-10000-sub3', openfig(['/ubc/cs/project/arrow/hutter/EPMs/results/matrix/2d/',name,'-10000-sub3-predmatrix-', el, '-RF-def.fig'])};
fighandles{end+1} = {'RF-def-10000-sub4', openfig(['/ubc/cs/project/arrow/hutter/EPMs/results/matrix/2d/',name,'-10000-sub4-predmatrix-', el, '-RF-def.fig'])};
fighandles{end+1} = {'RF-def-10000-sub5', openfig(['/ubc/cs/project/arrow/hutter/EPMs/results/matrix/2d/',name,'-10000-sub5-predmatrix-', el, '-RF-def.fig'])};
fighandles{end+1} = {'RF-def-10000-sub6', openfig(['/ubc/cs/project/arrow/hutter/EPMs/results/matrix/2d/',name,'-10000-sub6-predmatrix-', el, '-RF-def.fig'])};
fighandles{end+1} = {'RF-def-10000-sub7', openfig(['/ubc/cs/project/arrow/hutter/EPMs/results/matrix/2d/',name,'-10000-sub7-predmatrix-', el, '-RF-def.fig'])};
fighandles{end+1} = {'RF-def-10000-sub8', openfig(['/ubc/cs/project/arrow/hutter/EPMs/results/matrix/2d/',name,'-10000-sub8-predmatrix-', el, '-RF-def.fig'])};
fighandles{end+1} = {'RF-def-10000-sub9', openfig(['/ubc/cs/project/arrow/hutter/EPMs/results/matrix/2d/',name,'-10000-sub9-predmatrix-', el, '-RF-def.fig'])};
fighandles{end+1} = {'RF-def-10000-sub10', openfig(['/ubc/cs/project/arrow/hutter/EPMs/results/matrix/2d/',name,'-10000-sub10-predmatrix-', el, '-RF-def.fig'])};
fighandles{end+1} = {'RF-def-10000', openfig(['/ubc/cs/project/arrow/hutter/EPMs/results/matrix/2d/',name,'-10000-predmatrix-', el, '-RF-def.fig'])};

%%
function plot_figure(filename_prefix, matrix, min_val, max_val) 
matrix(1,1) = min_val;
matrix(end,end) = max_val;
h=image(matrix, 'CDataMapping', 'scaled');
h
%             colormap(hot);
% colorbar;
colormap(gray); 
h=colorbar;

dist_from_end = 50;
if size(matrix,2) < 300
    dist_from_end = ceil(size(matrix,2)/10);
end

set(gca, 'XTick', [dist_from_end,size(matrix,2)-dist_from_end], 'XTickLabel', {'easy','hard'})
set(gca, 'YTick', [dist_from_end,size(matrix,1)-dist_from_end], 'YTickLabel', {'good','bad'})
ylabel('configurations', 'FontSize', 22); 
xlabel('instances', 'FontSize', 22);

mini = min(min(matrix));
maxi = max(max(matrix));
set(gca, 'FontSize', 16);
set(h, 'YLim', [mini-1e-6,maxi+1e-6])

saveas(gcf, strcat(filename_prefix,'.fig'));
set(gcf, 'PaperPositionMode', 'auto');

pdf_filename = strcat(filename_prefix,'.pdf');
if exist(pdf_filename, 'file');
    delete(pdf_filename);
end
export_fig(pdf_filename);
fprintf(strcat('Saved plot to ', pdf_filename, '\n'));        
