function [subFunc, subTheta, sub_all_features, subNames] = use_param_feat_subset(func, Theta, all_features, names, selected_combined_idxs)

%== First, fix parts that depend on the combined indices.
tmpCat = [];
tmpCatDomains = {};
tmpCont = [];
tmpLower = [];
tmpUpper = [];
selected_combined_idxs=sort(selected_combined_idxs);
count = 0;
for i=1:length(selected_combined_idxs)
    if selected_combined_idxs(i) > size(Theta,2)
        break
    end
    count = count+1;
    if find(func.cat==selected_combined_idxs(i))
        tmpCat = [tmpCat, i];
        tmpCatDomains{i} = func.all_values{selected_combined_idxs(i)};
    else
        tmpCont = [tmpCont, i];
        tmpLower(i) = func.orig_param_lower_bound(selected_combined_idxs(i));
        tmpUpper(i) = func.orig_param_upper_bound(selected_combined_idxs(i));
    end
end

subFunc = func;
subFunc.dim = count;
subFunc.cat = tmpCat;
subFunc.all_values = tmpCatDomains;
subFunc.cont = setdiff(1:count, subFunc.cat);
subFunc.orig_param_lower_bound = tmpLower;
subFunc.orig_param_upper_bound = tmpUpper;
subNames = names(selected_combined_idxs);

%=== Now, fix Theta and all_features separately.
selected_param_idxs = [];
selected_feature_idxs = [];
for i=1:length(selected_combined_idxs)
    if selected_combined_idxs(i) <= size(Theta,2)
        selected_param_idxs(end+1) = selected_combined_idxs(i);
    else
        selected_feature_idxs(end+1) = selected_combined_idxs(i) - size(Theta,2);
    end
end
subTheta = Theta(:,selected_param_idxs);
sub_all_features = all_features(:,selected_feature_idxs);